    include     \masm32\include\masm32rt.inc    ; defaults to .386

.586

    include     timers.asm      ; requires a pentium

    LOOPCOUNT equ 1000000

    PROCS TEXTEQU <FStrLen,FStrLn2, \
                   Ratch,RatchX,RatchX2, \
                   StrLen,StrLen1,StrLen2, \
                   szLen,szLen1,szLen2,szLen3,szLen4, \
                   lstrlen >

    SIZES TEXTEQU <0,1,2,3,4,5,15,16,17,31,1023>

    %FOR proc,<PROCS>
         proc proto :DWORD
    ENDM

    MAXWIDTH  equ 20
    HDRWIDTH  equ 10
    COLWIDTH  equ 5

.data

    %FOR len,<SIZES>
         align 16
         str&len& db len dup ('X'),0
    ENDM

.code

align 16

sxFld proc DDpointer:DWORD, rvstring:DWORD, DDwidth:DWORD, DDalign:DWORD
    .if DDalign == 0
        invoke szLeft,DDpointer,rvstring,DDwidth
        invoke szLen,rvstring
        mov edx,rvstring
    @@: cmp eax,DDwidth
        jae @F
        mov byte ptr [edx+eax],32
        inc eax
        jmp @B
    @@: mov byte ptr [edx+eax],0
    .elseif DDalign == 1
        invoke szLen,DDpointer
        mov edx,rvstring
        xor ecx,ecx
    @@: cmp eax,DDwidth
        jae @F
        mov byte ptr [edx+ecx],32
        inc eax
        inc ecx
        jmp @B
    @@: add edx,ecx
        invoke szLeft,DDpointer,edx,DDwidth
    .endif
    ret 4*4

sxFld endp

fld$ MACRO DDpointer,DDwidth,DDalign:=<0>
    LOCAL rvstring
    .data
        rvstring db MAXWIDTH+4 dup (0)
        align 16
    .code
    invoke sxFld,reparg(DDpointer),ADDR rvstring,DDwidth,DDalign
    EXITM <ADDR rvstring>
ENDM

.code

align 16

start:

    print fld$(chr$("Proc/Bytes"),HDRWIDTH)
    %FOR len,<SIZES>
        invoke StrLen,ADDR str&len&
        print fld$(ustr$(eax),COLWIDTH,1)
    ENDM
    print chr$(13,10)

    print fld$(chr$("=========="),HDRWIDTH)
    %FOR len,<SIZES>
        invoke StrLen,ADDR str&len&
        print fld$(" ====",COLWIDTH)
    ENDM
    print chr$(13,10)

    %FOR proc,<PROCS>
        print fld$(chr$("&proc&"),HDRWIDTH)
        %FOR len,<SIZES>
            counter_begin LOOPCOUNT, HIGH_PRIORITY_CLASS
                invoke proc,ADDR str&len&
            counter_end
            mov ebx,eax
            print fld$(ustr$(ebx),COLWIDTH,1)
        ENDM
        print chr$(13,10)
    ENDM
    mov   eax,input(13,10,"Press enter to exit...")
    exit

; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 16

Ratch proc junk:dword      ; from Ratch           ;it all begins here
 MOV EAX,[ESP+DWORD]       ;address of string

 .REPEAT                   ;searching string ....
   MOV EDX,[EAX]           ;next 4 byte gulp (DWORD)
   ADD EAX,DWORD           ;EAX=character pointer
   LEA ECX,[EDX-01010101H] ;propagate if byte is zero
   NOT EDX                 ;set up test pattern
   AND EDX,ECX             ;leftmost bit of zero byte should now be set
   AND EDX,080808080H      ;sieve out zero bytes
 .UNTIL !ZERO?             ;check the next DWORD

                           ;we now know the current DWORD contains a zero byte
 SUB EAX,DWORD+BYTE        ;compensate for entry additions into loops

 .REPEAT                   ;searching current DWORD ...
   INC EAX                 ;increase word count if no carry from shift
   ROR EDX,8               ;bring leftmost bit of each byte into carry flag
 .UNTIL CARRY?             ;if carry flag set, byte is zero

 SUB EAX,[ESP+DWORD]       ;subtract beginning of string to get length

 RET DWORD                 ;all done, and string length in EAX

Ratch endp

align 16

RatchX proc junk:dword      ; modified Ratch
	mov eax,[esp+4]   		;address of string
@@:		                    ;searching string ....
	mov edx,[eax]           ;next 4 byte gulp (DWORD)
	add eax,4               ;eax=character pointer to next dword to test
	lea ecx,[edx-01010101H] ;propagate if byte is zero
	not edx                 ;set up test pattern
	and edx,ecx             ;leftmost bit of zero byte should now be set
	and edx,080808080H      ;sieve out zero bytes
	jz @b  		            ;check the next DWORD
                            ;we now know the current DWORD contains a zero byte
	sub eax,4      			;compensate for entry additions into loops

@@:				           ;searching current DWORD ...
	ror edx,8              ;bring leftmost bit of each byte into carry flag
	jc @f
	add eax,1              ;increase word count if no carry from shift
	ror edx,8              ;bring leftmost bit of each byte into carry flag
	jc @f
	add eax,1              ;increase word count if no carry from shift
	ror edx,8              ;bring leftmost bit of each byte into carry flag
	jc @f
	add eax,1              ;increase word count if no carry from shift
@@:
	sub eax,[esp+4]       ;subtract beginning of string to get length

	ret 4                 ;all done, and string length in EAX

RatchX endp

align 16

RatchX2 proc junk:dword      ; modified Ratch
	mov eax,[esp+4]   		;address of string
	nop
@@:		                    ;searching string ....
	mov edx,[eax]           ;next 4 byte gulp (DWORD)
	add eax,4               ;eax=character pointer to next dword to test
	lea ecx,[edx-01010101H] ;propagate if byte is zero
	not edx                 ;set up test pattern
	and edx,ecx             ;leftmost bit of zero byte should now be set
	and edx,080808080H      ;sieve out zero bytes
	jz @b  		            ;check the next DWORD
                            ;we now know the current DWORD contains a zero byte
	sub eax,4      			;compensate for entry additions into loops

@@:				           ;searching current DWORD ...
	ror edx,8              ;bring leftmost bit of each byte into carry flag
	jc @f
	add eax,1              ;increase word count if no carry from shift
	ror edx,8              ;bring leftmost bit of each byte into carry flag
	jc @f
	add eax,1              ;increase word count if no carry from shift
	ror edx,8              ;bring leftmost bit of each byte into carry flag
	jc @f
	add eax,1              ;increase word count if no carry from shift
@@:
	sub eax,[esp+4]       ;subtract beginning of string to get length

	ret 4                 ;all done, and string length in EAX

RatchX2 endp

align 16

FStrLen proc string:dword
        mov     ecx, [esp+4]
        xor     eax, eax            ; clear initial size 
    @@:
        mov     edx, [ecx+4*eax]
        lea     edx, [edx-1010101h] ; sub 1 from each byte in eax
        add     eax,1               ; ready for next dword
        and     edx, 80808080h      ; check sign bit in all byte
        jz      @B                  ; more to do until we have a sign
        test    edx, 000000FFh      ; is byte-1 zero?
        jnz     C_minus4            ;
        test    edx, 0000FF00h      ; is byte-2 zero?
        jnz     C_minus3            ;
        test    edx, 00FF0000h      ; is byte-3 zero?
        jnz     C_minus2            ;
    C_minus1:
        lea     eax,[4*eax-1]
        ret     1*4
    C_minus2:
        lea     eax,[4*eax-2]
        ret     1*4
    C_minus3:
        lea     eax,[4*eax-3]
        ret     1*4
    C_minus4:
        lea     eax,[4*eax-4]
        ret     1*4

FStrLen endp

align 16

FStrLn2 proc string:dword
        mov     ecx, [esp+4]
        xor     eax, eax            ; clear initial size 
    @@:
        mov     edx, [ecx+eax]
        lea     edx, [edx-1010101h] ; sub 1 from each byte in eax
        add     eax, 4              ; ready for next dword
        and     edx, 80808080h      ; check sign bit in all byte
        jz      @B                  ; more to do until we have a sign
        test    edx, 000000FFh      ; is byte-1 zero?
        jnz     C_minus4
        test    edx, 0000FF00h      ; is byte-2 zero?
        jnz     C_minus3
        test    edx, 00FF0000h      ; is byte-3 zero?
        jnz     C_minus2
    C_minus1:
        sub     eax,1
        ret     1*4
    C_minus2:
        sub     eax,2
        ret     1*4
    C_minus3:
        sub     eax,3
        ret     1*4
    C_minus4:
        sub     eax,4
        ret     1*4

FStrLn2 endp

align 16

StrLen1 proc item:DWORD

    push    ebx

    mov     eax, [esp+2*4]          ; get pointer to string
    lea     edx, [eax+3]            ; pointer+3 used in the end
align 4
@@:
    mov     ebx, [eax]              ; read first 4 bytes
    add     eax, 4                  ; increment pointer
    lea     ecx, [ebx-01010101h]    ; subtract 1 from each byte
    not     ebx                     ; invert all bytes
    and     ecx, ebx                ; and these two
    and     ecx, 80808080h
    jz      @B                      ; no zero bytes, continue loop

    test    ecx, 00008080h          ; test first two bytes
    jnz     @F

    shr     ecx, 16                 ; not in the first 2 bytes
    add     eax, 2

@@:
    shl     cl, 1                   ; use carry flag to avoid branch
    sbb     eax, edx                ; compute length

    pop     ebx

    ret     1*4

StrLen1 endp

align 16

StrLen2 proc src:DWORD

    mov     ecx, [esp+1*4]
    test    ecx, 3
    jz      @max8

@bucle:
    mov     al, [ecx]
    add     ecx, 1
    test    al, al
    jz      @lb1

    test    ecx, 3
    jnz     @bucle
align 4
@max8:
    mov     eax, [ecx]
    mov     edx, 7EFEFEFFh
    add     edx, eax
    xor     eax, 0FFFFFFFFh
    xor     eax, edx
    add     ecx, 4
    test    eax, 81010100h
    jz      @max8

    mov     eax, [ecx-4]
    test    al, al
    jz      @lb4

    test    ah, ah
    jz      @lb3

    test    eax, 0FF0000h
    jz      @lb2

    test    eax, 0FF000000h
    jnz     @max8

@lb1:
    lea     eax, [ecx-1]
    mov     ecx, [esp+1*4]
    sub     eax, ecx
    ret     1*4

@lb2:
    lea     eax, [ecx-2]
    mov     ecx, [esp+1*4]
    sub     eax, ecx
    ret     1*4

@lb3:
    lea     eax, [ecx-3]
    mov     ecx, [esp+1*4]
    sub     eax, ecx
    ret     1*4

@lb4:
    lea     eax, [ecx-4]
    mov     ecx, [esp+1*4]
    sub     eax, ecx
    ret     1*4

StrLen2 endp

align 16

szLen1 proc src:DWORD

    mov     eax, [esp+1*4]    ; src
    sub     eax, 4
align 4
@@:
    add     eax, 4
    cmp     BYTE PTR [eax], 0
    je      @lb1

    cmp     BYTE PTR [eax+1], 0
    je      @lb2

    cmp     BYTE PTR [eax+2], 0
    je      @lb3

    cmp     BYTE PTR [eax+3], 0
    jne     @B

    sub     eax, [esp+1*4]    ; src
    add     eax, 3
    ret     1*4

@lb3:
    sub     eax, [esp+1*4]    ; src
    add     eax, 2
    ret     1*4

@lb2:
    sub     eax, [esp+1*4]    ; src
    add     eax, 1
    ret     1*4

@lb1:
    sub     eax, [esp+1*4]    ; src
    ret     1*4

szLen1 endp

align 16

szLen2 proc src:DWORD

    mov     eax, [esp+1*4]    ; src
    sub     eax, 4
    xor     ecx, ecx
align 4
@@:
    add     eax, 4
    cmp     BYTE PTR [eax], cl
    je      @lb1

    cmp     BYTE PTR [eax+1], cl
    je      @lb2

    cmp     BYTE PTR [eax+2], cl
    je      @lb3

    cmp     BYTE PTR [eax+3], cl
    jne     @B

    sub     eax, [esp+1*4]    ; src
    add     eax, 3
    ret     1*4

@lb3:
    sub     eax, [esp+1*4]    ; src
    add     eax, 2
    ret     1*4

@lb2:
    sub     eax, [esp+1*4]    ; src
    add     eax, 1
    ret     1*4

@lb1:
    sub     eax, [esp+1*4]    ; src
    ret     1*4

szLen2 endp

align 16

szLen3 proc src:DWORD

    mov     eax, [esp+1*4]    ; src
    sub     eax, 4
    xor     ecx, ecx
align 4
@@:
    add     eax, 4
    mov     ecx, [eax]
    ;cmp    BYTE PTR [eax], 0
    test    cl, cl
    je      @lb1

    ;cmp    BYTE PTR [eax+1], 0
    test    ch, ch
    je      @lb2

    mov     ecx, [eax+2]
    ;cmp    BYTE PTR [eax+2], 0
    test    cl, cl
    je      @lb3

    ;cmp    BYTE PTR [eax+3], 0
    test    ch, ch
    jne     @B

    sub     eax, [esp+1*4]    ; src
    add     eax, 3
    ret     1*4

@lb3:
    sub     eax, [esp+1*4]    ; src
    add     eax, 2
    ret     1*4

@lb2:
    sub     eax, [esp+1*4]    ; src
    add     eax, 1
    ret     1*4

@lb1:
    sub     eax, [esp+1*4]    ; src
    ret     1*4

szLen3 endp

align 16

szLen4 proc src:DWORD

    mov     eax, [esp+1*4]    ; src
    sub     eax, 4
    ;xor    ecx, ecx
align 4
@@:
    add     eax, 4
    movzx   ecx, word ptr [eax]
    ;cmp    BYTE PTR [eax], 0
    test    cl, cl
    je      @lb1

    ;cmp    BYTE PTR [eax+1], 0
    test    ch, ch
    je      @lb2

    movzx   ecx, word ptr [eax+2]
    ;cmp    BYTE PTR [eax+2], 0
    test    cl, cl
    je      @lb3

    ;cmp    BYTE PTR [eax+3], 0
    test    ch, ch
    jne     @B

    sub     eax, [esp+1*4]    ; src
    add     eax, 3
    ret     1*4

@lb3:
    sub     eax, [esp+1*4]    ; src
    add     eax, 2
    ret     1*4

@lb2:
    sub     eax, [esp+1*4]    ; src
    add     eax, 1
    ret     1*4

@lb1:
    sub     eax, [esp+1*4]    ; src
    ret     1*4

szLen4 endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

end start

